=== modified file 'glitter/scroll_area.py'
--- glitter/scroll_area.py	2009-06-06 13:03:00 +0000
+++ glitter/scroll_area.py	2009-06-06 14:43:42 +0000
@@ -84,12 +84,34 @@
             _stage = self.get_stage()
             _stage.connect('key-press-event', self.do_key_press_event)
             
-        # Update background and scroll image layouts
+        # Update background layout
         self._background_image._update_layout()
+        
+        # Update scroll area layout, account for previous scroll position
+        x_factor = y_factor = 0.0
+        if self._scroll_image.get_xu() != 0:
+            x_factor = \
+              self._scroll_image.get_widthu() / self._scroll_image.get_xu()
+        if self._scroll_image.get_yu() != 0:
+            y_factor = \
+              self._scroll_image.get_heightu() / self._scroll_image.get_yu()
+        
         self._scroll_image._update_layout()  
         
+        if x_factor != 0:
+            self._scroll_image.set_xu(
+              self._scroll_image.get_widthu() / x_factor
+            )
+        if y_factor != 0:
+            self._scroll_image.set_yu(
+              self._scroll_image.get_heightu() / y_factor
+            )
+        
+        # Update layout for packed items
         for item in self._items:
             item._update_layout()
+            # FIXME: Raising item to top shouldn't be necessary  
+            item.raise_top()
 
         # Clip the scroll area
         self.set_clipu(0, 0, self.get_widthu(), self.get_heightu())
@@ -121,10 +143,12 @@
         self._vert_factor += vert_factor
         
         # Determine target x and y values for the scroll image
-        horiz_factor_as_units = self._horiz_factor * self._scroll_image.get_widthu()
+        horiz_factor_as_units = \
+          self._horiz_factor * self._scroll_image.get_widthu()
         target_x = self._scroll_image.get_xu() + horiz_factor_as_units
 
-        vert_factor_as_units = self._vert_factor * self._scroll_image.get_heightu()
+        vert_factor_as_units = \
+          self._vert_factor * self._scroll_image.get_heightu()
         target_y = self._scroll_image.get_yu() + vert_factor_as_units
         
         # Normalize targets out of bounds

